/*
 *  Copyright (C) 2007 Daniel Bessler <danielb@kiba-dock.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 *  Author : Daniel Bessler <danielb@kiba-dock.org>
 *
*/

#include <string.h>
#include <gtk/gtk.h>
#include <panel-applet.h>

#include <kiba-plugin.h>
#include <kiba-dock.h>
#include <kiba-object.h>
#include <kiba-prefs.h>
#include <kiba-macros.h>

#define PLUGIN_NAME "panel_applet"

/**
KibaObject creation
**/

static void kiba_panel_applet_create_object (PanelApplet *applet) {
	GtkWidget *object;
	KibaDock *dock;
	
	dock = kiba_dock_get_for_id ("PanelApplet");
	object = kiba_object_new (KIBA_OBJECT_WINDOW_VISIBLE, FALSE);
	
	SET_FLAG (KIBA_OBJECT(object)->props, KIBA_OBJECT_VISIBLE);
	SET_FLAG (KIBA_OBJECT(object)->props, KIBA_OBJECT_MOVEABLE);
	SET_FLAG (KIBA_OBJECT(object)->props, KIBA_OBJECT_PRELIGHTABLE);
	SET_FLAG (KIBA_OBJECT(object)->props, KIBA_OBJECT_ZOOMABLE);
	SET_FLAG (KIBA_OBJECT(object)->props, KIBA_OBJECT_BOUNCEABLE);
	SET_FLAG (KIBA_OBJECT(object)->props, KIBA_OBJECT_PULSEABLE);
	SET_FLAG (KIBA_OBJECT(object)->props, KIBA_OBJECT_ROTATEABLE);
	SET_FLAG (KIBA_OBJECT(object)->props, KIBA_OBJECT_REFLECTABLE);
	kiba_object_set_group (KIBA_OBJECT(object), "PanelApplet");
	
	gtk_container_add(GTK_CONTAINER(dock), object);
	gtk_widget_show(object);
	gtk_container_add(GTK_CONTAINER(object), GTK_WIDGET(applet));
}

/**
Plugin Functions
**/

static void plugin_unload (KibaPlugin *plugin) {
	
}

static gboolean plugin_load (KibaPlugin *plugin) {
// 	kiba_panel_applet_create_object (PANEL_APPLET(panel_applet_new()));
	
	return TRUE;
}

static PrefMember panel_applet_options[] = {
};

static KibaPluginVtable vtable = {
	PLUGIN_NAME,			/* id/name        */
	"PanelApplet Plugin for Kiba-Dock",	/* summary        */
	NULL,				/* description    */	

	"Daniel Bessler <danielb@kiba-dock.org>",
					/* author         */
	"http://www.kiba-dock.org",	/* homepage       */

	plugin_load,			/* load            */
	plugin_unload,			/* unload          */
};

KIBA_INIT_PLUGIN (vtable, panel_applet_options);
